package com.dav;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import java.io.File;
import java.security.*;
import java.util.Vector;

public class FileApplet extends JApplet
{
    private String path;

    private JLabel lblPath;
    private JList lstFiles;
    private JButton btnDelete;

    public FileApplet()
    {
        //assign LayoutManager to panel
        JPanel contentPane = (JPanel)this.getContentPane();
        contentPane.setLayout(new BorderLayout(10, 10));

        //add Label for Path on Top
        lblPath = new JLabel();
        contentPane.add(lblPath, BorderLayout.NORTH);

        //add List with all files of path to center
        lstFiles = new JList();
        contentPane.add(new JScrollPane(lstFiles), BorderLayout.CENTER);

        btnDelete = new JButton("Löschen");
        //add listener to button -> delete files
        btnDelete.addActionListener(new ActionListener()
        {
            public void actionPerformed(ActionEvent e)
            {
                Object selectedValues[] = lstFiles.getSelectedValues();
                for (int i = 0; i < selectedValues.length; i++)
                {
                    deleteFile(path + selectedValues[i]);
                }

                lstFiles.setListData(getFileList());
            }
        });
        //add button to bottom
        contentPane.add(btnDelete, BorderLayout.SOUTH);

        setPath("C:/");
    }

    public void setPath(String newpath)
    {
        newpath = newpath.replace("\\", "/");

        if (!newpath.endsWith("/"))
            newpath += "/";

        this.path = newpath;
        lblPath.setText(this.path);

        AccessController.doPrivileged(new PrivilegedAction()
        {
            public Object run()
            {
                lstFiles.setListData(getFileList());
                return null;
            }
        });
    }

    //return a vector containing the filenames in path
    public Vector<String> getFileList()
    {
        Vector<String> fileNames = new Vector<String>();

        try
        {
            File dir = new File(path);
            File[] fileList = dir.listFiles();
            for (File f : fileList)
            {
                if (!f.isDirectory())
                    fileNames.add(f.getName());
            }
        }
        catch (Exception ex) {}

        return fileNames;
    }

    public boolean deleteFile(String name)
    {
        File f = new File(name);

        if (!f.exists() || !f.canWrite() || f.isDirectory())
            return false;

        return f.delete();
    }
}
